/*
 *  This file is part of the KDE libraries
 *  Copyright (c) 2001 Michael Goffioul <tdeprint@swing.be>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License version 2 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 **/

#include "defcmds.h"

#include <tqregexp.h>
#include <tdestandarddirs.h>

TQString defaultCommand(const TQString& cmd)
{
	TQString	str(cmd);
	TQRegExp	r("%exe_(\\w+)");
	int	p(-1);
	if ((p=r.search(str)) != -1)
	{
		TQString	exe = TDEStandardDirs::findExe(r.cap(1));
		if (exe.isEmpty())
			exe = "/usr/bin/"+r.cap(1);
		str.replace(p, r.matchedLength(), exe);
	}
	return str;
}
